toolboxpath = '/n/fs/modelnet/SUN3DV2/SUNRGBDtoolbox';
addpath(genpath(toolboxpath));
load(fullfile(toolboxpath,'/traintestSUNRGBD/allsplit.mat'));
load(fullfile(toolboxpath,'Metadata/SUNRGBDMeta.mat'));
cls = {'bathtub','bed','bookshelf','box','chair','counter','desk','door','dresser','garbage_bin','lamp','monitor','night_stand','pillow','sink','sofa','table','tv','toilet'};
thresh_iou = [0.01,0.05:0.05:0.6,0.8:0.2:1];

vis = ture;
%% evaluation
iou_precision =[];
iou_recall =[];
label_precision =[];
iouHolistic_all = []; 
exampleresult = load('exampleresult.mat','predictedBbs','predictRoom');
for imageId = 1:length(alltest)
    % fake result always use same room and object boxes
    predictedBbs = exampleresult.predictedBbs;
    predictRoom = exampleresult.predictRoom;
    data = SUNRGBDMeta(imageId);
    % evaluate
    eval_result = eval_holisticScencePR(predictedBbs,data.groundtruth3DBB',thresh_iou,cls); 
    iouHolistic = eval_holisticScenceIoU(data,data.gtCorner3D,data.groundtruth3DBB',predictRoom,predictedBbs,vis);
    
    iou_precision = [iou_precision;eval_result.iou_precision];
    iou_recall = [iou_recall;eval_result.iou_recall];
    label_precision = [label_precision;eval_result.label_precision];
    iouHolistic_all = [iouHolistic_all iouHolistic];
end
%% plot and average
figure,
plot(thresh_iou,mean(iou_precision),'r','LineWidth',3);
hold on;
plot(thresh_iou,mean(iou_recall),'g','LineWidth',3);
plot(thresh_iou,mean(label_precision),'b','LineWidth',3);
legend({'geometric precision','geometric recall','recognition recall'},'FontSize',27)
%xlabel('IoU threshold');
axis([0 1 0 1])
iou_precision_average =  mean(iou_precision(:,6));
iou_recall_average =  mean(iou_recall(:,6));
label_precision_average =  100*mean(label_precision(:,6));
iouHolistic_average = mean(iouHolistic_all);
sprintf('Average:\n geometric precision: %.3f\n geometric recall: %.3f\n recognition recall: %.3f\n %.3f\n',...
    iou_precision_average,iou_recall_average,label_precision_average,iouHolistic_average)